
// Questo e` il file che include tutto il vtk.
// Qui metteremo gli include del vtk contornati dalla protezione
// per unicode.

/*
	Altrimenti si ha questo problema

	Questo e` l'errore

error LNK2001: unresolved external symbol
public: 

virtual char const * __thiscall
vtkObjectBase::GetClassNameW(void)const "
(?GetClassNameW@vtkObjectBase@@UBEPBDXZ)

Intanto dentro object base sembra che *non* ci sia nessuna
GetClassNameW, forse proprio perche` vtk non ha unicode installato, ma
quella GetClassNameW mi pare proprio una cosa da unicode.

Questa GetClassNameW non so proprio da dove venga fuori. Questo puo`
significare solo una cosa: che ce l'aggiunge il visual.

Naturalmente ce l'aggiunge il visual, ma non come credevi tu.
In realta` GetClassName e` una funzione di Win32 che, guardacaso, e`
la stessa che viene ridefinita in vtkObjectBase e in tutte le sue
discendenti, praticamente tutto il mondo vtk.

Succede pero`, che quando tu hai _UNICODE definito tutti gli include
del vtk hanno questa GetClassName che e` diventata GetClassNameW... e
quindi qui sta l'arcano. L'unica soluzione e` quella di fare un

#define GetClassName_OLD GetClassName
#undef  GetClassName

#include <tutto il vtk>

//alla fine ritorniamo con il nostro GetClassName messo al posto giusto.
#define GetClassName GetClassName_OLD

La cosa migliore da fare, secondo me, e` quella di aggiungere un file
di include chiamato

IncludeVtk.h

in cui metto tutti gli include del vtk protetti da quella define e
undefine.
*/
#pragma once

//tutto il problema nasce da UNICODE
#ifdef _UNICODE

//includo il vtk senza unicode.
#define ENDO_NAV_DEVO_RIPRISTINARE_UNICODE
#undef _UNICODE
#undef UNICODE

//#define GetClassName_OLD GetClassName

//perche` vtk e` stato compilato senza unicode e
//quindi esporta dalle dll la GetClassName con un
//A dopo.
/* #undef CreateDirectory */
/* #undef GetClassName */
/* #undef GetProp */
/* #undef RemoveProp */
/* #undef SetProp */
/* #undef SendMessage */
/* #undef GetCurrentTime // vtkTimerLog::GetCurrentTime */
/* #undef GetObject // vtkDataArrayCollectionIterator */

#undef CreateDirectory
#define CreateDirectory CreateDirectoryA

#undef RemoveProp
#define RemoveProp RemovePropA

#undef SetProp
#define SetProp SetPropA

#undef GetClassName
#define GetClassName GetClassNameA

#undef GetProp
#define GetProp GetPropA

#undef SendMessage
#define SendMessageA

#undef GetCurrentTime
#define GetCurrentTimeA

#undef GetObject
#define GetObjectA

#endif //if def unicode

//attenzione!, la lista e` ordinata.

#include "vtkActor.h"
#include "vtkActorCollection.h"
#include "vtkActor2DCollection.h"
#include "vtkArrowSource.h"
#include "vtkAssembly.h"
#include "vtkAssemblyNode.h"
#include "vtkAssemblyPath.h"
#include "vtkAVIWriter.h"
#include "vtkAxes.h"
#include "vtkAxisActor2D.h"
#include "vtkBMPReader.h"
#include "vtkCallbackCommand.h"
#include "vtkCamera.h"
#include "vtkCaptionActor2D.h"
#include "vtkCardinalSpline.h"
#include "vtkCellArray.h"
#include "vtkCellData.h"
#include "vtkCellLocator.h"
#include "vtkCellPicker.h"
#include "vtkClipDataSet.h"
#include "vtkClipPolyData.h"
#include "vtkColorTransferFunction.h"	
#include "vtkCommand.h"
#include "vtkConeSource.h"
#include "vtkContourFilter.h"
#include "vtkCoordinate.h"
#include "vtkCubeSource.h"
#include "vtkCylinderSource.h"
#include "vtkDataArray.h"
#include "vtkDataSetMapper.h"
#include "vtkDataSetReader.h"
#include "vtkDecimatePro.h"
#include "vtkDiscreteMarchingCubes.h"
#include "vtkDiskSource.h"
#include "vtkEllipticalButtonSource.h"
#include "vtkFileOutputWindow.h"
#include "vtkFloatArray.h"
#include "vtkFollower.h"
#include "vtkGenericCell.h"
#include "vtkGlyphSource2D.h"
#include "vtkImageActor.h"
#include "vtkImageBlend.h"
#include "vtkImageCast.h"
#include "vtkImageData.h"
#include "vtkImageData.h"
#include "vtkImageDataGeometryFilter.h"
#include "vtkImageImport.h"
#include "vtkImageImport.h"
#include "vtkImageMapToColors.h"
#include "vtkImagePlaneWidget.h"
#include "vtkImageReslice.h"
#include "vtkImageTracerWidget.h"
#include "vtkInteractorStyleImage.h"
#include "vtkInteractorStyleSwitch.h"
#include "vtkInteractorStyleTrackballActor.h"
#include "vtkInteractorStyleTrackballCamera.h"
#include "vtkKochanekSpline.h"
#include "vtkLegendBoxActor.h"
#include "vtkLight.h"
#include "vtkLightCollection.h"
#include "vtkLineSource.h"
#include "vtkLookupTable.h"
#include "vtkMassProperties.h"
#include "vtkMath.h"
#include "vtkMatrix4x4.h"
#include "vtkOBBTree.h"
#include "vtkObjectFactory.h"
#include "vtkOpenGlCamera.h"
#include "vtkOutlineFilter.h"
#include "vtkOutlineSource.h"
#include "vtkOutlineCornerSource.h"
#include "vtkPerspectiveTransform.h"
#include "vtkPlane.h"
#include "vtkPlaneCollection.h"
#include "vtkPlaneSource.h"
#include "vtkPointData.h"
#include "vtkPointData.h"
#include "vtkPointLocator.h"
#include "vtkPointPicker.h"
#include "vtkPoints.h"
#include "vtkPolyData.h"
#include "vtkPolyDataMapper.h"
#include "vtkPolyDataMapper.h"
#include "vtkPolyDataNormals.h"
#include "vtkPolydata.h"
#include "vtkProp3DCollection.h"
#include "vtkPropAssembly.h"
#include "vtkPropPicker.h"
#include "vtkProperty.h"
#include "vtkProperty2D.h"
#include "vtkQuadricDecimation.h"
#include "vtkRectangularButtonSource.h"
#include "vtkRenderer.h"
#include "vtkReverseSense.h"
#include "vtkSmoothPolyDataFilter.h"
#include "vtkSphereSource.h"
#include "vtkStripper.h"
#include "vtkSuperquadricSource.h"
#include "vtkTextMapper.h"
#include "vtkTextActor.h"
#include "vtkTextActor3D.h"
#include "vtkTextProperty.h"
#include "vtkTexture.h"
#include "vtkTexturedSphereSource.h"
#include "vtkTransform.h"
#include "vtkTransformFilter.h"
#include "vtkTransformPolyDataFilter.h"
#include "vtkTriangle.h"
#include "vtkTriangleFilter.h"
#include "vtkTubeFilter.h"
#include "vtkUnsignedShortArray.h"
#include "vtkUnsignedShortArray.h"
#include "vtkUnstructuredGrid.h"
#include "vtkVectorText.h"
#include "vtkVolume16Reader.h"
#include "vtkFileOutputWindow.h"
#include "vtkWin32OpenGLRenderWindow.h"
#include "vtkWin32RenderWindowInteractor.h"
#include "vtkWindowLevelLookupTable.h"
#include "vtkWindowToImageFilter.h"
#include "vtkWorldPointPicker.h"
#include "vtkXMLImageDataWriter.h"
#include "vtkXMLPolyDataReader.h"
#include "vtkXMLPolyDataWriter.h"


//LINO: notare che la lista e` in ordine alfabetico...
//se bisogna aggiungere dei file metterli in ordine


#ifdef ENDO_NAV_DEVO_RIPRISTINARE_UNICODE

//le funzioni vtk sono con la A finale
//perche` vtk e` in ascii, mentre io sono in unicode

#define vtkCreateDirectory CreateDirectoryA
#undef CreateDirectory
#define CreateDirectory CreateDirectoryW

#define vtkRemoveProp RemovePropA
#undef RemoveProp
#define RemoveProp RemovePropW

#define vtkSetProp SetPropA
#undef SetProp
#define SetProp SetPropW

#define vtkGetClassName GetClassNameA
#undef GetClassName
#define GetClassName GetClassNameW

#define vtkGetProp GetPropA
#undef GetProp
#define GetProp GetPropW

#define vtkSendMessage SendMessageA
#undef SendMessage
#define SendMessage SendMessageW

#define vtkGetCurrentTime GetCurrentTimeA
#undef GetCurrentTime
#define GetCurrentTime GetCurrentTimeW

#define vtkGetObject GetObjectA
#undef GetObject
#define GetObject GetObjectW

//ok ritorno in unicode
#define _UNICODE
#define UNICODE


#endif
