#include "StdAfx.h"
#include "3dViewCalc.h"
#include "InteractorStyle1.h"
#include "InteractorStyle2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

C3dViewCalc::C3dViewCalc()
{  
  m_pRenderWnd = vtkRenderWindow::New ();
  m_pInteractor = vtkWin32RenderWindowInteractor::New ();

  m_pInteractorStyle1 = InteractorStyle1::New ();
  m_pInteractorStyle2 = InteractorStyle2::New ();
}

C3dViewCalc::~C3dViewCalc(void)
{
  //I destroy the vtk object
  m_pInteractorStyle1->Delete ();
  m_pInteractorStyle2->Delete ();
  m_pInteractor->Delete();
  m_pRenderWnd->Delete();
 
  //! LORENZO: THIS METHOD IS CALLED TO UNREGISTER ALL THE OBJECT FACTORIES.
  //! IT IS CALLED TO FIX A BUG IN THE OBJECT FACTORIES UNREGISTERING MADE
  //! BY THE STATIC OBJECT vtkCleanUpObjectFactory defined inside the file
  //! vtkObjectFactory.xx
  vtkObjectFactory::UnRegisterAllFactories();
}
//-----------------------------------------------------------------------------
bool
C3dViewCalc::create(DWORD style, HWND parent, UINT id)
{
  id; style;

  m_pRenderWnd->SetParentId (parent);
  m_pInteractor->SetRenderWindow(m_pRenderWnd);
  m_pInteractor->SetInteractorStyle(m_pInteractorStyle1);

  RECT rect;
  ::GetClientRect(parent, &rect);
  m_pRenderWnd->SetSize(rect.right-rect.left,rect.bottom-rect.top);

  if (!m_pInteractor->GetInitialized())
    m_pInteractor->Initialize();

  ::ShowWindow(static_cast<vtkWin32OpenGLRenderWindow*>(m_pRenderWnd)
    ->GetWindowId(), SW_HIDE);

  return true;
}
//-----------------------------------------------------------------------------
HWND 
C3dViewCalc::getDisplay(void) const
{
  return static_cast<vtkWin32OpenGLRenderWindow*>(m_pRenderWnd)
    ->GetWindowId();
}
//-----------------------------------------------------------------------------
void
C3dViewCalc::draw()
{
  m_pRenderWnd->Render();
}
//-----------------------------------------------------------------------------