//**********************************************************************
//***                   This module is part of the                   ***
//***                     Endonavigation System                      ***
//***                                                                ***
//**********************************************************************
//*** Title,  ownership rights  and  intellectual property rights in ***
//*** the Software shall be retained by the applicable owner and may ***
//*** be protected by applicable copyright or other law.             ***
//*** You may not:                                                   ***
//*** 1) Modify, translate, reverse engineer, decompile, disassemble ***
//***    or create  derivative  works  based  upon  the Software  or ***
//***    Documentation.                                              ***
//*** 2) Copy  the Software  or  Documentation  (except for  back-up ***
//***    purposes).                                                  ***
//*** 3) Resell,  rent,  lease,  or otherwise transfer rights to the ***
//***    Software or Documentation.                                  ***
//*** 4) Remove any proprietary notices or labels on the Software or ***
//***    Documentation.                                              ***
//**********************************************************************
//
// Module Name/Description
// =======================
// Definition of the main interfaces available in the system
// 
// History
// =======
//
// Author        Date      Label       Reason
// ------------- --------- ----------- ---------------------------------
//
// Implementation Notes
// ====================
//
//**********************************************************************

#pragma once

class IAppEnvironment;

//-----------------------------------------------------------------------------
/*!
* \class IEndoDisplay 
* \brief Interface for display window.
* \author
*/
//-----------------------------------------------------------------------------
class IEndoDisplay
{ 
 public:
  //! Destructor
  virtual ~IEndoDisplay () {}

  ///this gets the underlying window.
  virtual HWND getDisplay(void) const = 0;

  //the generic drawing function
  virtual void draw() = 0;

  ///This function creates the display
  virtual bool create(DWORD style, HWND parent, UINT id) = 0;
};

//!----------------------------------------------------------------------
//! EOF
//
