// This MFC Samples source code demonstrates using MFC Microsoft Office Fluent User Interface 
// (the "Fluent UI") and is provided only as referential material to supplement the 
// Microsoft Foundation Classes Reference and related electronic documentation 
// included with the MFC C++ library software.  
// License terms to copy, use or distribute the Fluent UI are available separately.  
// To learn more about our Fluent UI licensing program, please visit 
// http://msdn.microsoft.com/officeui.
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// TestRibbonMFCView.cpp : implementation of the CTestRibbonMFCView class
//

#include "stdafx.h"
// SHARED_HANDLERS can be defined in an ATL project implementing preview, thumbnail
// and search filter handlers and allows sharing of document code with that project.
#ifndef SHARED_HANDLERS
#include "TestRibbonMFC.h"
#endif

#include "TestRibbonMFCDoc.h"
#include "TestRibbonMFCView.h"
#include "AppEnvironment.h"
#include "ViewsManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTestRibbonMFCView

IMPLEMENT_DYNCREATE(CTestRibbonMFCView, CView)

BEGIN_MESSAGE_MAP(CTestRibbonMFCView, CView)
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONUP()
	ON_WM_ERASEBKGND () 
END_MESSAGE_MAP()

// CTestRibbonMFCView construction/destruction

CTestRibbonMFCView::CTestRibbonMFCView()
{
}

CTestRibbonMFCView::~CTestRibbonMFCView()
{
}

BOOL CTestRibbonMFCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CTestRibbonMFCView drawing

void CTestRibbonMFCView::OnDraw(CDC* pDC)
{
	CTestRibbonMFCDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;
}

void CTestRibbonMFCView::OnRButtonUp(UINT /* nFlags */, CPoint point)
{
	ClientToScreen(&point);
	OnContextMenu(this, point);
}

void CTestRibbonMFCView::OnContextMenu(CWnd* /* pWnd */, CPoint point)
{
#ifndef SHARED_HANDLERS
	theApp.GetContextMenuManager()->ShowPopupMenu(IDR_POPUP_EDIT, point.x, point.y, this, TRUE);
#endif
}


//!----------------------------------------------------------------------------
BOOL 
CTestRibbonMFCView::OnEraseBkgnd (CDC *pDC)
{  
  CRect rct;
  this->GetClientRect(rct);
  
  pDC->FillRect (rct, &m_brush);
  
  return TRUE;
}

//!----------------------------------------------------------------------------
void 
CTestRibbonMFCView::OnInitialUpdate()
{
  CView::OnInitialUpdate ();

  CAppEnvironment *pEnv = ((CTestRibbonMFCApp*) AfxGetApp ())->GetAppEnvironment ();
  pEnv->GetViewManager ()->CreateDisplayWnd (this->GetSafeHwnd ());
}

// CTestRibbonMFCView diagnostics

#ifdef _DEBUG
void CTestRibbonMFCView::AssertValid() const
{
	CView::AssertValid();
}

void CTestRibbonMFCView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTestRibbonMFCDoc* CTestRibbonMFCView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestRibbonMFCDoc)));
	return (CTestRibbonMFCDoc*)m_pDocument;
}
#endif //_DEBUG


// CTestRibbonMFCView message handlers
