// This MFC Samples source code demonstrates using MFC Microsoft Office Fluent User Interface 
// (the "Fluent UI") and is provided only as referential material to supplement the 
// Microsoft Foundation Classes Reference and related electronic documentation 
// included with the MFC C++ library software.  
// License terms to copy, use or distribute the Fluent UI are available separately.  
// To learn more about our Fluent UI licensing program, please visit 
// http://msdn.microsoft.com/officeui.
//
// Copyright (C) Microsoft Corporation
// All rights reserved.

// TestRibbonMFCView.h : interface of the CTestRibbonMFCView class
//

#pragma once

class CTestRibbonMFCView : public CView
{
protected: // create from serialization only
	CTestRibbonMFCView();
	DECLARE_DYNCREATE(CTestRibbonMFCView)

// Attributes
public:
	CTestRibbonMFCDoc* GetDocument() const;

// Operations
public:

// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// Implementation
public:
	virtual ~CTestRibbonMFCView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:	
  virtual void OnInitialUpdate();
  virtual BOOL OnEraseBkgnd (CDC *pDC);

// Generated message map functions
protected:
	afx_msg void OnFilePrintPreview();
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	DECLARE_MESSAGE_MAP()

protected:
  CBrush m_brush;
};

#ifndef _DEBUG  // debug version in TestRibbonMFCView.cpp
inline CTestRibbonMFCDoc* CTestRibbonMFCView::GetDocument() const
   { return reinterpret_cast<CTestRibbonMFCDoc*>(m_pDocument); }
#endif

